
/*----------------------------------------------------------------------------\
|                            Sortable Table 1.04                              |
|-----------------------------------------------------------------------------|
|                         Created by Erik Arvidsson                           |
|                  (http://webfx.eae.net/contact.html#erik)                   |
|                      For WebFX (http://webfx.eae.net/)                      |
|-----------------------------------------------------------------------------|
| A DOM 1 based script that allows an ordinary HTML table to be sortable.     |
|-----------------------------------------------------------------------------|
|                  Copyright (c) 1998 - 2002 Erik Arvidsson                   |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| This  software is  available under the  three different licenses  mentioned |
| below.  To use this software you must chose, and qualify, for one of those. |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| The WebFX Non-Commercial License          http://webfx.eae.net/license.html |
| Permits  anyone the right to use the  software in a  non-commercial context |
| free of charge.                                                             |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| The WebFX Commercial license           http://webfx.eae.net/commercial.html |
| Permits the  license holder the right to use  the software in a  commercial |
| context. Such license must be specifically obtained, however it's valid for |
| any number of  implementations of the licensed software.                    |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - |
| GPL - The GNU General Public License    http://www.gnu.org/licenses/gpl.txt |
| Permits anyone the right to use and modify the software without limitations |
| as long as proper  credits are given  and the original  and modified source |
| code are included. Requires  that the final product, software derivate from |
| the original  source or any  software  utilizing a GPL  component, such  as |
| this, is also licensed under the GPL license.                               |
|-----------------------------------------------------------------------------|
| 2003-01-10 | First version                                                  |
| 2003-01-19 | Minor changes to the date parsing                              |
| 2003-01-28 | JScript 5.0 fixes (no support for 'in' operator)               |
| 2003-02-01 | Sloppy typo like error fixed in getInnerText                   |
| 2003-07-04 | Added workaround for IE cellIndex bug.                         |
|-----------------------------------------------------------------------------|
| Created 2003-01-10 | All changes are in the log above. | Updated 2003-07-04 |
\----------------------------------------------------------------------------*/


function SortableTable(strName, oTable, oSortTypes, bolHighlight, intDescending) {
    this.name = strName;
    this.element = oTable;
    this.tHead = oTable.tHead;
    this.tBody = oTable.tBodies[0];
    this.document = oTable.ownerDocument || oTable.document;
    this.highlight = bolHighlight;

    this.sortColumn = null;

    if (intDescending==1){
        this.descending = true;
    }else{
        this.descending = false;
    }

    var oThis = this;
    this._headerOnclick = function (e) {
    	oThis.headerOnclick(e);
    };

    // only IE needs this
    var win = this.document.defaultView || this.document.parentWindow;
    this._onunload = function () {
    	oThis.destroy();
    };
    if (win && typeof win.attachEvent != "undefined") {
    	win.attachEvent("onunload", this._onunload);
    }

    this.initHeader(oSortTypes || []);
}

SortableTable.gecko = navigator.product == "Gecko";
SortableTable.msie = /msie/i.test(navigator.userAgent);
// Mozilla is faster when doing the DOM manipulations on
// an orphaned element. MSIE is not
SortableTable.removeBeforeSort = SortableTable.gecko;

SortableTable.prototype.onsort = function () {};

// adds arrow containers and events
// also binds sort type to the header cells so that reordering columns does
// not break the sort types
SortableTable.prototype.initHeader = function (oSortTypes) {
	var cells = this.tHead.rows[0].cells;
	var l = cells.length;
	var img, c;
	for (var i = 0; i < l; i++) {
		c = cells[i];
		img = this.document.createElement("IMG");
		img.src = "images/blank.png";
		c.appendChild(img);
		if (oSortTypes[i] != null) {
			c._sortType = oSortTypes[i];
		}
		if (typeof c.addEventListener != "undefined")
			c.addEventListener("click", this._headerOnclick, false);
                else if (typeof c.attachEvent != "undefined")
			c.attachEvent("onclick", this._headerOnclick);
	}
	this.updateHeaderArrows();
};

// remove arrows and events
SortableTable.prototype.uninitHeader = function () {
    
    // IE does something weird and we need to return if we do not have these objects
    if(!this) return;
    if(!this.tHead) return;
    if(!this.tHead.rows) return;
    if(!this.tHead.rows[0]) return;
    
	var cells = this.tHead.rows[0].cells;
	var l = cells.length;
	var c;
	for (var i = 0; i < l; i++) {
		c = cells[i];
		c.removeChild(c.lastChild);
		if (typeof c.removeEventListener != "undefined")
			c.removeEventListener("click", this._headerOnclick, false);
		else if (typeof c.detachEvent != "undefined")
			c.detachEvent("onclick", this._headerOnclick);
	}
};

SortableTable.prototype.updateHeaderArrows = function () {
	var cells = this.tHead.rows[0].cells;
	var l = cells.length;
	var img;
	for (var i = 0; i < l; i++) {
		img = cells[i].lastChild;
		if (i == this.sortColumn)
			img.className = "sort-arrow " + (this.descending ? "descending" : "ascending");
		else
			img.className = "sort-arrow";
	}
};

SortableTable.prototype.headerOnclick = function (e) {
	// find TD element
	var el = e.target || e.srcElement;
	while (el.tagName != "TD")
		el = el.parentNode;
    var index = SortableTable.msie ? SortableTable.getCellIndex(el) : el.cellIndex;

	this.sort(index);

    //store the last stored column
        //alert(this.tHead.rows[0].cells[index]._sortType);;    
    if (this.descending){
        try{
            SetLastColumnUsed(index,1,this.name);
        }catch(e){            
        }
    }else{
        try{
            SetLastColumnUsed(index,0,this.name);
        }catch(e){            
        }
    }

};

// IE returns wrong cellIndex when columns are hidden
SortableTable.getCellIndex = function (oTd) {
	var cells = oTd.parentNode.childNodes
	var l = cells.length;
	var i;
	for (i = 0; cells[i] != oTd && i < l; i++)
		;
	return i;
};

SortableTable.prototype.getSortType = function (nColumn) {
	var cell = this.tHead.rows[0].cells[nColumn];
	var val = cell._sortType;
	if (val != "")
		return val;
	return "String";
};

// only nColumn is required
// if bDescending is left out the old value is taken into account
// if sSortType is left out the sort type is found from the sortTypes array
SortableTable.prototype.sort = function (nColumn, bDescending, sSortType) {
	if (sSortType == null)
		sSortType = this.getSortType(nColumn);

	// exit if None
	if (sSortType == "None")
		return;

	if (bDescending == null) {
//		if (this.sortColumn != nColumn)
//			this.descending = true;
//		else
//			this.descending = !this.descending;
            if (this.sortColumn == nColumn)  this.descending = !this.descending;
	}

	this.sortColumn = nColumn;

	if (typeof this.onbeforesort == "function")
		this.onbeforesort();

	var f = this.getSortFunction(sSortType, nColumn);
	var a = this.getCache(sSortType, nColumn);
	var tBody = this.tBody;

	a.sort(f);

	if (this.descending)
		a.reverse();

	if (SortableTable.removeBeforeSort) {
		// remove from doc
		var nextSibling = tBody.nextSibling;
		var p = tBody.parentNode;
		p.removeChild(tBody);
	}

	// insert in the new order
	var l = a.length;
	for (var i = 0; i < l; i++)
		tBody.appendChild(a[i].element);

	if (SortableTable.removeBeforeSort) {
		// insert into doc
		p.insertBefore(tBody, nextSibling);
	}

	this.updateHeaderArrows();

	this.destroyCache(a);

	if (typeof this.onsort == "function")
		this.onsort();

    //code needed to change the
    //highlight to the selected
    //need to change class for these
    rowback = "even";
    for (i=0; i < this.element.rows.length; i++) {
        for (j=0; j < this.element.rows[i].cells.length; j++) {
              if (j==nColumn){
                   if (i==0){
                        this.element.rows[i].cells[j].className="selectedcolumn-header";
                   }else if (rowback == "even") {
                         if (this.highlight){
                             if ((this.element.rows[i].cells[j].className=="")||(this.element.rows[i].cells[j].className=="selectedcolumn-cell-even")||(this.element.rows[i].cells[j].className=="selectedcolumn-cell-odd")){
                                         this.element.rows[i].cells[j].className="selectedcolumn-cell-even";
                             }
                             rowback = "odd";
                         }
                   }else if (rowback == "odd") {
                         if (this.highlight){
                             if ((this.element.rows[i].cells[j].className=="")||(this.element.rows[i].cells[j].className=="selectedcolumn-cell-even")||(this.element.rows[i].cells[j].className=="selectedcolumn-cell-odd")){
                                  this.element.rows[i].cells[j].className="selectedcolumn-cell-odd";
                             }

                             rowback = "even";
                         }
                   }
              }else{
                   if (i==0){
                        this.element.rows[i].cells[j].className="";
                   }else{
                    //check if class is something other than odd even ( custome class )
                    //leave it alone if it does
                        if (this.highlight){
                            if ((this.element.rows[i].cells[j].className=="")||(this.element.rows[i].cells[j].className=="selectedcolumn-cell-even")||(this.element.rows[i].cells[j].className=="selectedcolumn-cell-odd")){
                                 this.element.rows[i].cells[j].className="";
                            }
                        }
                   }
              }
        }
    }
};

SortableTable.prototype.asyncSort = function (nColumn, bDescending, sSortType) {
	var oThis = this;
	this._asyncsort = function () {
		oThis.sort(nColumn, bDescending, sSortType);
	};
	window.setTimeout(this._asyncsort, 1);
};

SortableTable.prototype.getCache = function (sType, nColumn) {
	var rows = this.tBody.rows;
	var l = rows.length;
	var a = new Array(l);
	var r;
	for (var i = 0; i < l; i++) {
		r = rows[i];
		a[i] = {
			value:		this.getRowValue(r, sType, nColumn),
			element:	r
		};
	};
	return a;
};

SortableTable.prototype.destroyCache = function (oArray) {
	var l = oArray.length;
	for (var i = 0; i < l; i++) {
		oArray[i].value = null;
		oArray[i].element = null;
		oArray[i] = null;
	}
}

SortableTable.prototype.getRowValue = function (oRow, sType, nColumn) {
	var s;
	var c = oRow.cells[nColumn];
	if (typeof c.innerText != "undefined")
		s = c.innerText;
	else
		s = SortableTable.getInnerText(c);
	return this.getValueFromString(s, sType);
};

SortableTable.getInnerText = function (oNode) {
	var s = "";
	var cs = oNode.childNodes;
	var l = cs.length;
	for (var i = 0; i < l; i++) {
		switch (cs[i].nodeType) {
			case 1: //ELEMENT_NODE
				s += SortableTable.getInnerText(cs[i]);
				break;
			case 3:	//TEXT_NODE
				s += cs[i].nodeValue;
				break;
		}
	}
	return s;
}

SortableTable.prototype.getValueFromString = function (sText, sType) {
	switch (sType) {
                case "TimeElapsed":
                    for (var i = 0; i < timeElapsedItems.length; i++) {
                        if (timeElapsedItems[i] == sText) {
                            return Number(timeElapsedValues[i]);
                        }
                    }
                    break;
                case "Money":
                    var parts = sText.split(" ");

                    // Currency sign can be to the left or to the right
                    if (!isNaN(parseFloat(parts[0]))) {
                        return Number(parts[0]);
                    } else if (!isNaN(parseFloat(parts[1]))) {
                        return Number(parts[1]);
                    } else {
                        return sText;
                    }
                case "convertDMYT2num":
                    return convertDMYT2num(sText);
                case "convertMDYT2num":
                    return convertDMYT2num(sText);
		case "Number":
			return Number(sText);
		case "CaseInsensitiveString":
			return sText.toUpperCase();
		case "Date":
			var parts = sText.split("-");
			var d = new Date(0);
                        var testDate = String(parts[0]);

                        if(testDate.length>2){
                            d.setFullYear(parts[0]);
                            d.setDate(parts[2]);
                            d.setMonth(parts[1] - 1);
                        }else{
                            if (testDate.length==0){
                                d.setFullYear(2909);
                                d.setDate(19);
                                d.setMonth(4);
                            }else{
       			        d.setFullYear(parts[2]);
       			        d.setDate(parts[1]);
       			        d.setMonth(parts[0] - 1);
                            }
                        }
       			return d.valueOf();
  	}
	return sText;
};

SortableTable.prototype.getSortFunction = function (sType, nColumn) {
	return function compare(n1, n2) {
		if (n1.value < n2.value) {
			return -1;
        }
		if (n2.value < n1.value) {
			return 1;
        }
		return 0;
	};
};

SortableTable.prototype.destroy = function () {
	this.uninitHeader();
	var win = this.document.parentWindow;
	if (win && typeof win.detachEvent != "undefined") {	// only IE needs this
		win.detachEvent("onunload", this._onunload);
	}
	this._onunload = null;
	this.element = null;
	this.tHead = null;
	this.tBody = null;
	this.document = null;
	this._headerOnclick = null;
	this.sortTypes = null;
	this._asyncsort = null;
	this.onsort = null;
};


function convertDMYT2num(str, dateRegex)
{
    if (typeof dateRegex == 'undefined') {
        var dateRegex = /(\d\d)\/(\d\d)\/(\d\d\d\d) (\d\d):(\d\d) ((a|p)m)/;
    }
    var match = dateRegex.exec(str);

    var tDate = new Date();
    tDate.setDate(match[1]);
    tDate.setMonth(match[2] - 1);
    tDate.setYear(match[3]);
    if (match[7] == 'p' && match[4] != '12') {
        var hours = parseInt(match[4]) + 12;
    } else {
        var hours = match[4];
    }
    tDate.setHours(hours);
    tDate.setMinutes(match[5]);

    return (tDate.getTime());
}

function convertMDYT2num(str)
{
    var dateRegex = /(\d\d)\/(\d\d)\/(\d\d\d\d) (\d\d):(\d\d) ((a|p)m)/;
    return convertDMYT2num(str, dateRegex);
}
